c     **********************************************************

      subroutine calcflux

c     calculates flux from object

      implicit none

      include 'ds.txt'
      include 'stokes.txt'
      
      real*8 rnorm,fimage,delp,hstnorm,rtmp
      
      integer i,ia,ix,iy,it,icenter
      
c     normalization 
c     for binning in cos(theta)
c     rnorm=dmu*dfloat(np)*r2p
c     for binning in theta
      rnorm=pi/float(nmu)*dfloat(np)*r2p
c     given this norm, flux from star is 1/4pi.  let's multiply
c     output by 4*pi (divide rnorm) so flux from star is 1.
      rnorm=rnorm/(r2p*2.d0)
      hstnorm=dfloat(np)
      do ia=1,3
      do i=1,nmu
         rtmp=dfloat(nums(i,ia))
         if (rtmp.gt.1.d0)  then
c     errors, first, standard deviations
            si2(i,ia)=dsqrt((si2(i,ia)-(si(i,ia)**2)/rtmp)/(rtmp-1.d0))
            sq2(i,ia)=dsqrt((sq2(i,ia)-(sq(i,ia)**2)/rtmp)/(rtmp-1.d0))
            su2(i,ia)=dsqrt((su2(i,ia)-(su(i,ia)**2)/rtmp)/(rtmp-1.d0))
            sv2(i,ia)=dsqrt((sv2(i,ia)-(sv(i,ia)**2)/rtmp)/(rtmp-1.d0))
c     divide by average intensity per photon (assumes error
c     in I is 0)
            rtmp=si(i,ia)/dfloat(nums(i,ia))
            si2(i,ia)=si2(i,ia)/rtmp
            sq2(i,ia)=sq2(i,ia)/rtmp
            su2(i,ia)=su2(i,ia)/rtmp
            sv2(i,ia)=sv2(i,ia)/rtmp
c     somewhat poisson in that errors should go down with more photons
            rtmp=dsqrt(dfloat(nums(i,ia)))
            si2(i,ia)=si2(i,ia)/rtmp+1.d0/rtmp
            sq2(i,ia)=sq2(i,ia)/rtmp
            su2(i,ia)=su2(i,ia)/rtmp
            sv2(i,ia)=sv2(i,ia)/rtmp	   
         endif
c     if binning in cos(theta)
c     si(i,ia)=si(i,ia)/rnorm
c     sq(i,ia)=sq(i,ia)/rnorm
c     su(i,ia)=su(i,ia)/rnorm
c     sv(i,ia)=sv(i,ia)/rnorm
c     if binning in theta
         si(i,ia)=si(i,ia)/rnorm/sini(i)
         sq(i,ia)=sq(i,ia)/rnorm/sini(i)
         su(i,ia)=su(i,ia)/rnorm/sini(i)
         sv(i,ia)=sv(i,ia)/rnorm/sini(i)
         spi(i,ia)=spi(i,ia)/rnorm/sini(i)
         spq(i,ia)=spq(i,ia)/rnorm/sini(i)
         spu(i,ia)=spu(i,ia)/rnorm/sini(i)
         spv(i,ia)=spv(i,ia)/rnorm/sini(i)
      end do
      rtmp=dfloat(numt(ia))
      if (rtmp.gt.1.d0) then
c     standard_deviation
         ti2(ia)=dsqrt((ti2(ia)-(ti(ia)**2)/rtmp)/(rtmp-1.d0))
         tq2(ia)=dsqrt((tq2(ia)-(tq(ia)**2)/rtmp)/(rtmp-1.d0))
         tu2(ia)=dsqrt((tu2(ia)-(tu(ia)**2)/rtmp)/(rtmp-1.d0))
         tv2(ia)=dsqrt((tv2(ia)-(tv(ia)**2)/rtmp)/(rtmp-1.d0))
c     divide by average i per photon
         rtmp=ti(ia)/dfloat(numt(ia))
         ti2(ia)=ti2(ia)/rtmp
         tq2(ia)=tq2(ia)/rtmp
         tu2(ia)=tu2(ia)/rtmp
         tv2(ia)=tv2(ia)/rtmp
c     account for somewhat poisson nature
         rtmp=dsqrt(dfloat(numt(ia)))
         ti2(ia)=ti2(ia)/rtmp+1.d0/rtmp
         tq2(ia)=tq2(ia)/rtmp
         tu2(ia)=tu2(ia)/rtmp
         tv2(ia)=tv2(ia)/rtmp
      endif
      ti(ia)=ti(ia)/hstnorm
      tq(ia)=tq(ia)/hstnorm
      tu(ia)=tu(ia)/hstnorm
      tv(ia)=tv(ia)/hstnorm
      tis(ia)=tis(ia)/hstnorm
      tqs(ia)=tqs(ia)/hstnorm
      tus(ia)=tus(ia)/hstnorm
      tvs(ia)=tvs(ia)/hstnorm
      end do
      
      fimage=0.
      icenter=nx/2+1
      do it=1,nmu
c     if binning in cos(theta)
c     star(it)=star(it)/(rnorm)
c     if binning in theta
          star(it)=star(it)/(rnorm)/sini(it)
      end do

      do it=1,nmu
      do ix=1,nx
      do iy=1,nx
c     standard deviation of imagei array
         rtmp=dfloat(numi(ix,iy,it))
         if (image2(ix,iy,it).gt.1.d0) then
c     print*,'rtmp',rtmp
            image2(ix,iy,it)=(image2(ix,iy,it)-imagei(ix,iy,it)**2/rtmp)
     1           /rtmp/(rtmp-1.d0)
         endif
         if(ix.eq.icenter.and.iy.eq.icenter) then
            write(6,*) 'image before norm'
     1           ,image(icenter,icenter,it),icenter,it
         end if
         if(image(ix,iy,it).lt.0.d0) then
            write(6,*) 'before normalizing'
            write(6,*) 'image lt 0',image(ix,iy,it),ix,iy,it
         end if
c     if binning in cos(Theta)
c     image(ix,iy,it)=image(ix,iy,it)/(rnorm)
c     if binning in theta
         image(ix,iy,it)=image(ix,iy,it)/(rnorm)/sini(it)
         fimage=fimage+(image(ix,iy,it))/dfloat(nmu)
         if(ix.eq.icenter.and.iy.eq.icenter) then
            write(6,*) 'image(icenter,icenter,it),icenter,it'
     1           ,image(icenter,icenter,it),icenter,it
         end if
      end do
      end do
      end do

      do ix=1,nxhst
      do iy=1,nxhst
         tihst(ix,iy)=tihst(ix,iy)/(hstnorm)
         tqhst(ix,iy)=tqhst(ix,iy)/(hstnorm)
         tuhst(ix,iy)=tuhst(ix,iy)/(hstnorm)
         tvhst(ix,iy)=tvhst(ix,iy)/(hstnorm)
      enddo
      enddo
      
      write(6,*)'flux from image',fimage
      
      return
      end
      
           
c     *********************************************************
