c     *********************************************************

      subroutine output(cfile)

      implicit none

      include 'ds.txt'
      include 'out.txt'
      include 'stokes.txt'
      include 'opacin.txt'
      include 'mrncoef.txt'
      include 'grid.txt'
      
      real*8 dflux,scatave,cpusec,cpuhrs,cpumin,sec
     1     ,noise,err,error
     1     ,dx,pos,x,y,pol,rnorm,tnorm
      real fq,fu,fqp,fup,fi,time(2),etime,fvp,fv,fp

      integer i,ia,imin,ihrs,ix,iy,it,singdig,it1,it2

      character filnam*15,charnum*2,numbers*30,cfile*80

      open(unit=16,file='dflux.out',status='unknown')
      do it=1,nmu
         write(16,*) sngl(star(it))
      end do
      close(16)

      singdig=9
      numbers='12345678901234567890123456789'

c     write out images
      if (writeim.eq.1) then
      do it=1,nmu
c      do it=12,12
         if (it.gt.19) then
            charnum='2'//numbers(it:it)
         else if (it.gt.9) then
	    charnum='1'//numbers(it:it)
         else
	    charnum='0'//numbers(it:it)
         end if
         filnam='image'//charnum//'.dat'
         open(unit=16,file=filnam,status='unknown')
         do iy=1,nx
            write(16,*) (sngl(image(ix,iy,it)),ix=1,nx)
         end do
         close(16)
c     filnam='image2_'//charnum//'.dat'
c     open(unit=16,file=filnam,status='unknown')
c     do iy=1,nx
c     write(16,*) (sngl(image2(ix,iy,it)),ix=1,nx)
c     end do
c     close(16)
         filnam='imagei'//charnum//'.dat'
         open(unit=16,file=filnam,status='unknown')
         do iy=1,nx   
            write(16,*) (sngl(imagei(ix,iy,it)),ix=1,nx)
         end do
         close(16)
         filnam='imageq'//charnum//'.dat'
         open(unit=16,file=filnam,status='unknown')
         do iy=1,nx   
            write(16,*) (sngl(imageq(ix,iy,it)),ix=1,nx)
         end do
         close(16)
         filnam='imageu'//charnum//'.dat'
         open(unit=16,file=filnam,status='unknown')
         do iy=1,nx   
            write(16,*) (sngl(imageu(ix,iy,it)),ix=1,nx)
         end do
         close(16)
         filnam='imagev'//charnum//'.dat'
         open(unit=16,file=filnam,status='unknown')
         do iy=1,nx   
            write(16,*) (sngl(imagev(ix,iy,it)),ix=1,nx)
         end do
         close(16)
      end do
      endif
      
      open(unit=11,file='flux.out',status='unknown')
      open(unit=13,file='sflux.out',status='unknown')
      write(11,*) 
     $     'cost,          i,          q/i,          u/i,          v/i'
      write(13,*) 
     $     'cost,          i,          q/i,          u/i,          v/i'
c     if binning in mu
c     rnorm=dfloat(np)/dfloat(nmu)
c     if binning in theta
      tnorm=pi/float(nmu)*dfloat(np)*0.5d0
c     see subroutine calcflux for explanation of rnorm and tnorm
      do ia=1,3
      do i=1,nmu
c     if binning in theta
         rnorm=tnorm*sini(i)
         if(spi(i,ia).eq.0.0d+00) then
            fqp=0.
            fup=0.
            fvp=0.
         else
            fqp=sngl(spq(i,ia)/spi(i,ia))
            fup=sngl(spu(i,ia)/spi(i,ia))
            fvp=sngl(spv(i,ia)/spi(i,ia))
         end if
         if(si(i,ia).eq.0.d0) then
            fq=0.
            fu=0.
            fv=0.
         else
            fq=sngl(sq(i,ia)/si(i,ia))
            fu=sngl(su(i,ia)/si(i,ia))
            fv=sngl(sv(i,ia)/si(i,ia))
         end if
         write(11,*) sngl(u(i)),sngl(si(i,ia)),fq,fu,fv
         write(13,*) sngl(u(i)),sngl(spi(i,ia)),fqp,fup,fvp
      end do
      end do
      close(11)
      close(13)

      open(unit=11,file='fluxerr.out',status='unknown')
      write(11,*) 'standard deviations of i,q,u,v'
      write(11,*) 'normalize to i for q,u,v to compare directly with'
      write(11,*) '    flux file (assumes i has no error) '
      write(11,*) 
     1'  cost,       sig_i,         sig_q/i,      sig_u/i,      sig_v/i'
      do ia=1,3
      do i=1,nmu
         if(nums(i,ia).le.1) then
            fi=0.
            fq=0.
            fu=0.
            fv=0.
            fp=0.
         else
            fi=sngl(si2(i,ia)*si(i,ia))
            fq=sngl(sq2(i,ia))
            fu=sngl(su2(i,ia))
            fv=sngl(sv2(i,ia))
            fp=1./sqrt(float(nums(i,ia)))*sngl(si(i,ia))
         endif
         write(11,*) sngl(u(i)),fi,fq,fu,fv
      end do
      enddo
      close(11)

c     flux
      flux=flux+aflux
c     flux which hits disk
      dflux=tot/flux
c     scattered flux
      if(nscat.gt.0) then
	  scatave=nscat/sflux
       else
	  scatave=0.
       end if
       sflux=sflux/flux
c     absorbed flux
       aflux=aflux/flux
c     cpu time
       cpusec=etime(time)
       cpuhrs=cpusec/3600.
       ihrs=int(cpuhrs)
       cpumin=(cpuhrs-ihrs)*60.
       imin=int(cpumin)
       sec=(cpumin-imin)*60.

       it1=int(thete/10)
       it2=mod(thete,10)
       if (it2.eq.0) it2=10
       charnum=numbers(it1:it1)//numbers(it2:it2)
       if (ipeel.eq.1) then
          open(unit=13,file='peelflux_'//charnum//'.out'
     1       ,status='unknown')
          write(13,*) 'flux and polarization in the 3 apertures '
          write(13,*)
     1     '  I              Q/I              U/I               V/I'
          write(13,*) 'total flux'
          do i=1,3
             if(ti(i).eq.0.d0) then
                fq=0.
                fu=0.
                fv=0.
             else
                fq=sngl(tq(i)/ti(i))
                fu=sngl(tu(i)/ti(i))
                fv=sngl(tv(i)/ti(i))
             end if
             write(13,*) sngl(ti(i)),fq,fu,fv
          enddo
          write(13,*) 'scattered flux only'
          do i=1,3
             if(tis(i).eq.0.d0) then
                fq=0.
                fu=0.
                fv=0.
             else
                fq=sngl(tqs(i)/tis(i))
                fu=sngl(tus(i)/tis(i))
                fv=sngl(tvs(i)/tis(i))
             end if
             write(13,*) sngl(tis(i)),fq,fu,fv
          enddo
          write(13,*) 'total - scatter flux ( = direct)'
          do i=1,3
             write(13,*) sngl(ti(i)-tis(i))
          enddo
          write(13,*) ' standard deviations in the 3 apertures '
          write(13,*)
     1' sigI          sig(Q/I)     sig(U/I)     sig(V/I)     Poisson(I)'
          do ia=1,3
             if(numt(ia).le.1) then
                fi=0.
                fq=0.
                fu=0.
                fv=0.
                fp=0.
             else
                fi=sngl(ti2(ia)*ti(ia))
                fq=sngl(tq2(ia))
                fu=sngl(tu2(ia))
                fv=sngl(tv2(ia))
                fp=1./sqrt(float(numt(ia)))*sngl(ti(ia))
             endif
             write(13,*) fi,fq,fu,fv,fp
          end do
          close(13)
          
          open(unit=21,file='peelI_'//charnum//'.dat',status='unknown')
          open(unit=22,file='peelQ_'//charnum//'.dat',status='unknown')
          open(unit=23,file='peelU_'//charnum//'.dat',status='unknown')
          open(unit=24,file='peelV_'//charnum//'.dat',status='unknown')
          do iy=1,nxhst
             write(21,*) (sngl(tihst(ix,iy)),ix=1,nxhst)
             write(22,*) (sngl(tqhst(ix,iy)),ix=1,nxhst)
             write(23,*) (sngl(tuhst(ix,iy)),ix=1,nxhst)
             write(24,*) (sngl(tvhst(ix,iy)),ix=1,nxhst)
          end do
          close(21)
          close(22)
          close(23)
          close(24)
       endif      

       write(12,*) 'photons   ',np
       write(12,*) 'image size: rmaxi (au), nx',sngl(rmaxi/au),nx
       write(12,*) 'nxhst ',nxhst
       write(12,*) 'aperture sizes in au',
     1      (sngl(sqrt(aperturesq(i))/au),i=1,3)
       write(12,*) 'make peeled images? 1=yes ',ipeel
       write(12,*) 'STELLAR PARAMETERS '
       write(12,*) 'stellar radius ', sngl(rstar)
       write(12,*) 'stellar mass ',sngl(massc)
       write(12,*) 'limb darkening (0 for no, 1 for yes)',limb
       write(12,*) 'DUST PARAMETERS '
       write(12,*) 'idust? 0=electron; 1, dust; 2 dust tables ',idust
       if (idust.gt.0) then
          write(12,*) 'opacity, albedo, g, pl ',sngl(kappa),sngl(rlam),
     $         sngl(g),sngl(pl)
       else
          write(12,*) 'opacity, albedo, pl ',sngl(kappa),sngl(rlam),
     $         sngl(pl)
       endif
      if (idust.eq.2)   write(12,*) 'dust file used ',cfile
       write(12,*) 'ENVELOPE PARAMETERS'
       write(12,*) 'rmine in AU, rstar ',sngl(rmine/au),
     $      sngl(rmine/rstar/rsol)
       write(12,*) 'rmaxe (AU) ',sngl(rmaxe/au)
       write(12,*) 'mass envelope (solar), taumax0 ',sngl(massenv),
     $      sngl(taumax0)
       write(12,*) 'geometry (bub,hour, or cap): ',GEOM
       if (GEOM.eq.'bub') then
          write(12,*) 'ebub, thick ',sngl(ebub),sngl(thick)
       else if (geom.eq.'hour') then
          write(12,*) 'thethour, thick ',sngl(thetcut*180./pi),
     1         sngl(thick)
       else if (geom.eq.'cap') then
          write(12,*) 'thetcap1, thetcap2, thick',sngl(thetcap1),
     $         sngl(thetcap2),sngl(thick)
       else
          write(12,*) 'error in geometry'
       endif
       write(12,*) 'density in envelope goes as rho1*r^-er1,rho2*r^-er2'
       write(12,*) 'rho1, er1, rho2, er2 ',sngl(rho1),sngl(er1),
     $      sngl(rho2),sngl(er2)
       write(12,*) 'DISK PARAMETERS'
       write(12,*) 'optical depth along disk midplane (taumax90) ',
     $      sngl(taumax90)
       write(12,*) 'rmind,zmax,zmin (au)',sngl(rmind/au),sngl(zmax/au),
     $      sngl(zmin/au)
       write(12,*) 'mass disk,tau(90) ',sngl(massd/msol),sngl(taumax90)
       write(12,*) 'z=z1*(r/r0)**b. b = ',sngl(b)
       write(12,*) 'rho(z=0)=rh0*(r/r0)**(-a). rho0, a = ',sngl(rhod0),
     $      sngl(a)
       write(12,*) 'tauzmin,tauz30,tauzmax ',sngl(tauzmin),sngl(tauz30)
     $      ,sngl(tauzmax)
       write(12,*) 'density at rmind,30AU,rmaxd',sngl(rhomin),
     $      sngl(rho30),sngl(rhomax)
       write(12,*) 'GRID PARAMETERS'
       write(12,*) 'nrg,ntg,npg ',nrg,ntg,npg
       write(12,*) 'rexp, texp (1 for linear) ',sngl(rexp),sngl(texp)
       write(12,*) 'OUTPUT '
       write(12,*) 'total flux', sngl(flux)
       write(12,*) 'flux which hits disk+envelope',sngl(dflux)
       write(12,*) 'scattered flux',sngl(sflux)
       write(12,*) 'ave number of scatters in this flux',sngl(scatave)
       write(12,*) 'flux which gets absorbed',sngl(aflux)
       write(12,*) 'cputime: ',ihrs,' hrs ',imin,' min ',sngl(sec),
     $      ' sec'
       close(12)
	
       return
       end


